program MindBus2;
{ V.0900 18.02.96     1. spielbare Version mit Animated Buttons }
{        19.02.96     Enderoutine, Level einstellen             }



uses dos,crt,graph,intuit,drivers;

const titel='U J A '' s   M i n d b u s t e r  II        V1.000       TP6';
      imafile='Mind2_1.ima';
      xmax=5; ymax=5; dx=32; dy=32; ox=154; oy=128;
      pal:array[0..15,0..2] of word=
      (( 0,  0,  0),(31, 18,  0), (41, 24,  0), (52, 31,  0),
       (63, 38,  0), (63, 46, 20), (63, 54, 41), (34,  5, 11),
       (29, 60, 57), ( 0, 57, 51), ( 0, 49, 46), ( 0, 42, 41),
       ( 0, 34, 34), ( 0, 26, 27), ( 0, 18, 20), (63, 63, 63));


type feld  =array[1..xmax,1..ymax] of integer;


var ok,ende,fertig,timeron:boolean;
    ima          :array[1..5] of Image;
    igad         :array[1..7] of Gadget;
    chip         :array[1..25] of Image;
    itext1,itext2:array[1..4] of IntuiText;
    sinfo        :StrInfo;
    ch           :char;
    g,mx,my,i,l,c:integer;
    f            :feld;
    ho,mi,se,tic :word;

{$i \inc\getstrg8.inc }

procedure background;
var i,j,k,anz:integer;
    fh       :file;
    temp     :string;
    ima0     :image;
begin
   rectfill(0,0,639,479,7);

   rectfill(4,4,635,27,0);
   rectfill(5,5,634,26,1);
   rectfill(6,6,633,25,13);
   rectfill(7,7,632,24,3);
   rectfill(8,8,631,23,4);
   rectfill(9,9,630,22,5);
   rectfill(10,10,629,21,15);
   rectfill(11,11,629,21,6);

   rectfill(4,452,635,475,0);
   rectfill(5,453,634,474,1);
   rectfill(6,454,633,473,13);
   rectfill(7,455,632,472,3);
   rectfill(8,456,631,471,4);
   rectfill(9,457,630,470,5);
   rectfill(10,458,629,469,15);
   rectfill(11,459,629,469,6);
   setcolor(15); outtextxy(129,12,titel);
   setcolor(0);  outtextxy(128,12,titel);

   assign(fh,imafile);
   reset(fh,1);
   BlockRead(fh,ima0,sizeof(image));
   with ima0 do begin
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      BlockRead(fh,p_data^,anz);
      PutImage(91,65,p_data^,normalput);
      Freemem(p_data,anz);
   end;
   close(fh);
   temp:=imafile;
   temp[7]:='2';
   assign(fh,temp);
   reset(fh,1);
   BlockRead(fh,ima0,sizeof(image));
   with ima0 do begin
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      BlockRead(fh,p_data^,anz);
      PutImage(264,65,p_data^,normalput);
      Freemem(p_data,anz);
   end;
   close(fh);

   temp[7]:='3';
   assign(fh,temp);
   reset(fh,1);
   BlockRead(fh,ima[1],sizeof(image));
   with ima[1] do begin
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      BlockRead(fh,p_data^,anz);
   end;
   close(fh);
   temp[7]:='4';
   assign(fh,temp);
   reset(fh,1);
   BlockRead(fh,ima[2],sizeof(image));
   with ima[2] do begin
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      BlockRead(fh,p_data^,anz);
   end;
   close(fh);
   temp[7]:='5';
   assign(fh,temp);
   reset(fh,1);
   BlockRead(fh,ima[5],sizeof(image));
   with ima[5] do begin
      anz:=Imagesize(1,1,width,height);
      GetMem(p_data,anz);
      BlockRead(fh,p_data^,anz);
   end;
   close(fh);
   k:=0;
   for i:=1 to ymax do for j:=1 to xmax do begin
      inc(k);
      with chip[k] do begin
         x:=0;
         y:=0;
         width:=dx;
         height:=dy;
         p_nextimage:=nil;
         anz:=Imagesize(1,1,width,height);
         GetMem(p_data,anz);
         GetImage(ox+j*dx,oy+i*dy,ox+j*dx+pred(dx),oy+i*dy+pred(dy),chip[k].p_data^);
     end;
   end;

   PutImage(524,108,ima[1].p_data^,normalput);
   temp:='Zeit:';
   setcolor(15); outtextxy(539,120,temp);
   setcolor(0);  outtextxy(538,120,temp);

end;



procedure initintuit;
var i,k,k2:integer;
begin
   itext1[1].itext:='N';
   itext1[2].itext:='Q';
   itext1[3].itext:='Turns:';
   for i:=1 to 3 do with itext1[i] do begin
      x:=14;
      y:=14;
      if i=3 then begin x:=12; y:=12; end;
      fpen:=15;
      bpen:=2;
      drmode:=jam1;
      p_nexttext:=addr(itext2[i]);
   end;
   itext2:=itext1;
   for i:=1 to 3 do with itext2[i] do begin
      x:=pred(itext1[i].x);
      fpen:=0;
      p_nexttext:=nil;
   end;


   with sinfo do begin
      x:=32;
      y:=24;
      maxlen:=3;
      fpen:=0;
      bpen:=6;
      buff:='3';
      ubuff:='';
  end;


   for i:=1 to 7 do with igad[i] do begin
      id:=i;
      case i of
      1: begin x:=596; y:=384; width:=32; height:=32; end;
      2: begin x:=596; y:=416; width:=32; height:=32; end;
      3: begin x:=524; y:=64;  width:=64; height:=44; end;
      4: begin x:=ox+dx; y:=81; width:=5*dx; height:=dy; end;
      5: begin x:=107; y:=oy+dy; width:=dx; height:=5*dy; end;
      6: begin x:=ox+dx; y:=367;  width:=5*dx; height:=dy; end;
      7: begin x:=393; y:=oy+dy;  width:=dx; height:=5*dy; end;
      end;

      bpen:=-1;
      hibpen:=bpen;
      p_loborder:=nil;
      p_hiborder:=p_loborder;
      case i of
      1..2: p_loimage:=addr(ima[2]);
      3   : p_loimage:=addr(ima[1]);
      4..7: p_loimage:=nil;
      end;

      p_hiimage:=p_loimage;
      if i<4 then p_lointuitext:=addr(itext1[i]) else p_lointuitext:=nil;
      p_hiintuitext:=p_lointuitext;
      if i=3 then gadgettyp:=Strgadget else gadgettyp:=boolgadget;
      onoff:=false;
      active:=true;
      if i=3 then p_specialinfo:=addr(sinfo) else p_specialinfo:=nil;
      if i<7 then p_nextgadget:=addr(igad[succ(i)])
      else igad[i].p_nextgadget:=nil;
   end;
   RefreshGadgets(addr(igad[1]));

   k:=Imagesize(1,1,dx,ymax*dy);
   k2:=Imagesize(1,1,dx,1);
   getmem(ima[3].p_data,k);
   getmem(ima[4].p_data,k2);

end;






{ ------------------------------------------------------------------------ }

procedure setcolors;
var i:integer;
begin
   for i:=0 to 15 do setrgbpalette(i,pal[i,0],pal[i,1],pal[i,2]);
end;

procedure darken;
var i:integer;
begin
   for i:=0 to 15 do setpalette(i,0);
end;

procedure lighten;
var i:integer;
begin
   for i:=0 to 15 do setpalette(i,i);
end;

{ ------------------------------------------------------------------------ }

procedure initfeld(var f:feld);
var i,j,k:integer;
begin
k:=0;
for j:=1 to ymax do for i:=1 to xmax do begin
   inc(k);
   f[i,j]:=k;
   PutImage(i*dx+ox,j*dy+oy,chip[k].p_data^,normalput);
end;
end;


procedure moveup(mx,my:integer; var f:feld);
var x,i,k:integer;
begin
   x:=(mx-ox) div dx;
   k:=f[x,1];
   for i:=2 to ymax do f[x,pred(i)]:=f[x,i];
   f[x,ymax]:=k;
   for i:=1 to dy do begin
      getimage(x*dx+ox,oy+dy+1,ox+x*dx+pred(dx),oy+ymax*dy+pred(dy),ima[3].p_data^);
      getimage(ox+x*dx,oy+dy,  ox+dx*x+pred(dx),oy+dy,ima[4].p_data^);
      putimage(ox+x*dx,oy+dy,ima[3].p_data^,normalput);
      putimage(ox+x*dx,oy+ymax*dy+pred(dy),ima[4].p_data^,normalput);
   end;
end;

procedure movedown(mx,my:integer; var f:feld);
var x,i,k:integer;
begin
   x:=(mx-ox) div dx;
   k:=f[x,ymax];
   for i:=ymax downto 2 do f[x,i]:=f[x,pred(i)];
   f[x,1]:=k;
   for i:=1 to dy do begin
      getimage(x*dx+ox,oy+dy,ox+x*dx+pred(dx),oy+ymax*dy+pred(dy)-1,ima[3].p_data^);
      getimage(ox+x*dx,oy+ymax*dy+pred(dy),ox+dx*x+pred(dx),oy+ymax*dy+pred(dy),ima[4].p_data^);
      putimage(ox+x*dx,oy+dy+1,ima[3].p_data^,normalput);
      putimage(ox+x*dx,oy+dy,ima[4].p_data^,normalput);
   end;
end;

procedure moveright(mx,my:integer; var f:feld);
var y,i,k:integer;
begin
   y:=(my-oy) div dy;
   k:=f[xmax,y];
   for i:=xmax downto 2 do f[i,y]:=f[pred(i),y];
   f[1,y]:=k;
   for i:=1 to dx do begin
      getimage(ox+dx,oy+y*dy,ox+xmax*dx+pred(dx)-1,oy+y*dy+pred(dy),ima[3].p_data^);
      getimage(ox+pred(xmax*dx+dx),oy+y*dy,ox+pred(xmax*dx+dx),oy+y*dy+pred(dy),ima[4].p_data^);
      putimage(ox+dx,oy+y*dy,ima[4].p_data^,normalput);
      putimage(ox+dx+1,oy+y*dy,ima[3].p_data^,normalput);
   end;
end;

procedure moveleft(mx,my:integer; var f:feld);
var y,i,k:integer;
begin
   y:=(my-oy) div dy;
   k:=f[1,y];
   for i:=1 to pred(xmax) do f[i,y]:=f[succ(i),y];
   f[xmax,y]:=k;
   for i:=1 to dx do begin
      getimage(ox+dx+1,oy+y*dy,ox+xmax*dx+pred(dx),oy+y*dy+pred(dy),ima[3].p_data^);
      getimage(ox+dx,  oy+y*dy,ox+dx,              oy+y*dy+pred(dy),ima[4].p_data^);
      putimage(ox+dx,oy+y*dy,ima[3].p_data^,normalput);
      putimage(ox+xmax*dx+pred(dx),oy+y*dy,ima[4].p_data^,normalput);
   end;
end;








procedure mischen(l:integer; var f:feld);
var i,j,k:integer;
begin
randomize;
delay(1000);
for i:=1 to l do begin
   j:=random(1000) mod 4;
   k:=succ(random(1000) mod xmax);
   case j of
   0: moveup(k*dx+ox,0,f);
   1: movedown(k*dx+ox,0,f);
   2: moveleft(0,k*dy+oy,f);
   3: moveright(0,k*dy+oy,f);
   end;
   delay(500);
end;
end;

procedure fanfare;
var i,j,k,m,n:integer;
begin
for m:=1 to 10 do begin
k:=0;
for j:=1 to ymax do for i:=1 to xmax do begin
   inc(k);
   putimage(i*dx+ox,j*dy+oy,chip[k].p_data^,normalput);
end;
for j:=1 to ymax do for i:=1 to xmax do begin
   putimage(i*dx+ox,j*dy+oy,ima[5].p_data^,normalput);
end;
delay(100);
end;
end;



function updattime(ho,mo,so,po:word):integer;
var h,m,s,p:word;
    temp   :string;
    sec    :integer;
begin
gettime(h,m,s,p);
p:=p-po; if p<0 then begin dec(s); p:=p+100; end;
s:=s-so; if s<0 then begin dec(m); s:=s+60; end;
m:=m-mo; if m<0 then begin dec(h); m:=m+60; end;
h:=h-ho;
sec:=60*(h*60+m)+s;
str(sec:4,temp);
hidemouse;
rectfill(540,132,580,140,6);
setcolor(15); outtextxy(541,132,temp+'s');
setcolor(0); outtextxy(540,132,temp+'s');
showmouse;
updattime:=sec;
end;


begin
initscreen(ok);
if ok then begin
   darken;
   setcolors;
   background;
   initintuit;
   initfeld(f);
   lighten;
   val(igad[3].p_specialinfo^.buff,l,i);
   mischen(l,f);
   gettime(ho,mi,se,tic);
   ende:=false;
   timeron:=true;
   c:=0;
   while not ende do begin
      showmouse;
      repeat
         delay(10);
         c:=succ(c) mod 48;
         if c=0 then if timeron then i:=updattime(ho,mi,se,tic);
         getgadget(addr(igad[1]),g,mx,my);
         if keypressed then begin
            ch:=readkey;
               case ch of
               #27,'Q','q': g:=2;
               'N','n':     g:=1;
               '+':         begin
                               if l<99 then inc(l);
                               g:=3;
                            end;
               '-':         begin
                               if l>1 then dec(l);
                               g:=3;
                            end;
               end;
            ch:='#';
         end;
      until (g>0);
      hidemouse;

      case g of
      1: begin
            darken;
            initfeld(f);
            lighten;
            val(igad[3].p_specialinfo^.buff,l,i);
            mischen(l,f);
            gettime(ho,mi,se,tic);
            timeron:=true;
         end;
      2: ende:=true;
      3: begin
            getstring(g);
            val(igad[g].p_specialinfo^.buff,l,i);
            if l<1 then l:=1;
            if l>25 then l:=25;
            DrawGadget(addr(igad[g]));
            darken;
            initfeld(f);
            lighten;
            mischen(l,f);
            gettime(ho,mi,se,tic);
            timeron:=true;
         end;
      4: moveup(mx,my,f);
      5: moveleft(mx,my,f);
      6: movedown(mx,my,f);
      7: moveright(mx,my,f);
      end;
      if g>3 then begin
         fertig:=true;
         i:=0;
         for my:=1 to ymax do for mx:=1 to xmax do begin
            inc(i);
            if f[mx,my]<>i then fertig:=false;
         end;
         if fertig then begin timeron:=false; fanfare;  end;
      end;
   end; {ende}
end;

textmode(3);
end.

